/// <reference types="angular" />
/// <reference types="angular-route" />
/// <reference types="node" />
import { userdata, api, entityCtrl, entitiesCtrl } from "./CommonControllers";
import { TokenUser, NoderedUser, Base, Role, stripe_invoice, Customer, Resource, ResourceVariant, ResourceUsage } from "@openiap/openflow-api";
import { RPAWorkflow, Provider, Form, WorkflowInstance, Workflow, unattendedclient } from "./Entities";
import { WebSocketClientService } from "./WebSocketClientService";
import { Workitem, WorkitemQueue } from "@openiap/openflow-api";
export declare class jsutil {
    static ensureJQuery(): Promise<void>;
    static loadScript(url: string): Promise<void>;
    static getScript(url: string): Promise<void>;
}
export declare class MenuCtrl {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    user: TokenUser;
    signedin: boolean;
    path: string;
    searchstring: string;
    halfmoon: any;
    static $inject: string[];
    customer: Customer;
    customers: Customer[];
    allowclick: boolean;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    routeChangeStart(event: any, next: any, current: any): void;
    hasrole(role: string): boolean;
    showmanagecustomer(): boolean;
    hascordova(): boolean;
    stopimpersonation(): void;
    PathIs(path: string): boolean;
    toggleDarkMode(): void;
    toggleSidebar(): void;
    Search(): void;
    EditCustomer(customer: any): Promise<void>;
    SelectCustomer(customer: any): Promise<void>;
    setCookie(cname: any, cvalue: any, exdays: any): void;
    getCookie(cname: any): string;
    NewFeaturesTour: any;
    Shepherd: any;
    StartNewFeaturesTour(startfrom: any): void;
    ListTours(): void;
    OpenAdminsMenu(): void;
    CloseAllMenus(): void;
    StartManageCompanyTour(): void;
    StartManageDataTour(): void;
    StartManageRobotsAndNoderedTour(): void;
}
export declare class RPAWorkflowCtrl extends entityCtrl<RPAWorkflow> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    arguments: any;
    users: TokenUser[];
    user: TokenUser;
    messages: string;
    queuename: string;
    timeout: string;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    RegisterQueue(): Promise<void>;
    loadUsers(): Promise<void>;
    submit(): Promise<void>;
}
export declare class RPAWorkflowsCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    message: string;
    charts: chartset[];
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
    dographs(): Promise<void>;
    download(data: any, filename: any, type: any): void;
    Download(model: any): Promise<void>;
}
export declare class WorkflowsCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    message: string;
    charts: chartset[];
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processData(): Promise<void>;
}
export declare class chartset {
    options: any;
    baseColors: [
        '#97BBCD',
        '#DCDCDC',
        '#F7464A',
        '#46BFBD',
        '#FDB45C',
        '#949FB1',
        '#4D5360'
    ];
    colors: string[];
    type: string;
    heading: string;
    labels: string[];
    series: string[];
    data: any[];
    ids: any[];
    charttype: string;
    click: any;
}
export declare function emit(k: any, v: any): any;
export declare class ReportsCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    message: string;
    charts: chartset[];
    datatimeframe: Date;
    onlinetimeframe: Date;
    timeframedesc: string;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    settimeframe(days: any, hours: any, desc: any): void;
    processData(): Promise<void>;
    robotsclick(points: any, evt: any): Promise<void>;
    robotclick(points: any, evt: any): Promise<void>;
    workflowclick(points: any, evt: any): Promise<void>;
    InsertNew(): Promise<void>;
    UpdateOne(item: any): Promise<any>;
}
export declare class MainCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    showcompleted: boolean;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
}
export declare class LoginCtrl {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    localenabled: boolean;
    scanning: boolean;
    qrcodescan: boolean;
    providers: any;
    username: string;
    password: string;
    message: string;
    domain: string;
    allow_user_registration: boolean;
    forgot_pass_emails: boolean;
    static $inject: string[];
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, WebSocketClientService: WebSocketClientService, api: api);
    readfile(filename: string): Promise<string>;
    writefile(filename: string, content: string): Promise<void>;
    scanForQRScanner(): void;
    Scan(): void;
    QRScannerHit(err: any, value: any): Promise<void>;
    BeginForgotPassword(): void;
    submit(): Promise<void>;
    Signup(): void;
    setCookie(cname: any, cvalue: any, exdays: any): void;
    getCookie(cname: any): string;
    usernameblur(): void;
}
export declare class ProvidersCtrl extends entitiesCtrl<Provider> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: any;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: any, userdata: userdata);
}
export declare class ProviderCtrl extends entityCtrl<Provider> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    newforceddomain: string;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    submit(): Promise<void>;
    deleteforceddomains(id: any): void;
    addforceddomains(): void;
}
export declare class UsersCtrl extends entitiesCtrl<TokenUser> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    stripe: any;
    proration: boolean;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processData(): Promise<void>;
    Impersonate(model: TokenUser): Promise<any>;
    Resources: Resource[];
    Assigned: ResourceUsage[];
    user: TokenUser;
    ShowPlans(user: TokenUser): Promise<void>;
    AssignCount(Product: ResourceVariant): number;
    ToggleModal(): void;
    CloseModal(): void;
    ToggleNextInvoiceModal(): void;
    CloseNextInvoiceModal(): void;
    RemovePlan(resource: Resource, product: ResourceVariant): Promise<void>;
    AddPlan2(): Promise<void>;
    private resource;
    private product;
    nextinvoice: stripe_invoice;
    period_start: string;
    period_end: string;
    AddPlan(resource: Resource, product: ResourceVariant): Promise<void>;
}
export declare class UserCtrl extends entityCtrl<TokenUser> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    newid: string;
    memberof: Role[];
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): Promise<void>;
    deleteid(id: any): void;
    addid(): void;
    removedmembers: Role[];
    RemoveMember(model: Role): void;
    submit(): Promise<void>;
}
export declare class RolesCtrl extends entitiesCtrl<Role> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
}
export declare class RoleCtrl extends entityCtrl<Role> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    searchFilteredList: Role[];
    searchSelectedItem: Role;
    searchtext: string;
    e: any;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    submit(): Promise<void>;
    RemoveMember(model: any): void;
    AddMember(model: any): void;
    restrictInput(e: any): boolean;
    setkey(e: any): void;
    handlekeys(): void;
    handlefilter(e: any): Promise<void>;
    fillTextbox(searchtext: any): void;
}
export declare class FilesCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    file: string;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    Download(id: string): Promise<void>;
    b64toBlob(b64Data: string, contentType: string, sliceSize?: number): Blob;
    Upload(): Promise<void>;
    Upload_usingapi(): Promise<void>;
}
export declare class EntitiesCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    collections: any;
    showrunning: boolean;
    showpending: boolean;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
    SelectCollection(): void;
    DropCollection(): Promise<void>;
}
export declare class FormsCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
}
export declare class FormResourcesCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
}
export declare class FormResourceCtrl extends entityCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    newforceddomain: string;
    collections: any[];
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    collapsobject(o: any): void;
    expandobject(o: any): void;
    postload(): void;
    submit(): Promise<void>;
    fixtextarea(): void;
}
export declare class EditFormCtrl extends entityCtrl<Form> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    message: string;
    charts: chartset[];
    formBuilder: any;
    Formiobuilder: any;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    Save(): Promise<void>;
    renderform(): Promise<void>;
}
export declare class FormCtrl extends entityCtrl<WorkflowInstance> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    message: string;
    formRender: any;
    formioRender: any;
    workflow: Workflow;
    form: Form;
    instanceid: string;
    myid: string;
    submitbutton: string;
    queuename: string;
    localexchangequeue: string;
    queue_message_timeout: number;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    RegisterExchange(exchange: string): Promise<void>;
    RegisterQueue(): Promise<void>;
    hideFormElements(): Promise<void>;
    loadData(): Promise<void>;
    SendOne(queuename: string, message: any): Promise<void>;
    Save(): Promise<void>;
    traversecomponentsPostProcess(components: any[], data: any): void;
    traversecomponentsMakeDefaults(components: any[]): void;
    traversecomponentsAddCustomValidate(components: any[]): void;
    sleep(ms: any): Promise<unknown>;
    beforeSubmit(submission: any, next: any): Promise<void>;
    renderform(): Promise<void>;
}
export declare class EntityCtrl extends entityCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    searchFilteredList: TokenUser[];
    searchSelectedItem: TokenUser;
    searchtext: string;
    e: any;
    newkey: string;
    showjson: boolean;
    jsonmodel: string;
    message: string;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    gettype(obj: any): "string" | "number" | "bigint" | "boolean" | "symbol" | "undefined" | "object" | "function";
    getinputtype(obj: any, key: any): "number" | "text" | "checkbox";
    processdata(): void;
    isobject(object: any): boolean;
    fixtextarea(): void;
    togglejson(): void;
    submit(): Promise<void>;
    removekey(key: any): void;
    addkey(): void;
    removeuser(_id: any): void;
    adduser(): void;
    isBitSet(base64: string, bit: number): boolean;
    setBit(base64: string, bit: number): string;
    unsetBit(base64: string, bit: number): string;
    toogleBit(a: any, bit: number): void;
    _base64ToArrayBuffer(string_base64: any): ArrayBuffer;
    _arrayBufferToBase64(array_buffer: any): string;
    restrictInput(e: any): boolean;
    setkey(e: any): void;
    handlekeys(): void;
    handlefilter(e: any): Promise<void>;
    fillTextbox(searchtext: any): void;
}
export declare class HistoryCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    id: string;
    model: Base;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    isNew: boolean;
    ProcessData(): Promise<void>;
    ToggleModal(): void;
    CompareNow(model: any): Promise<void>;
    ShowVersion(model: any): Promise<void>;
    download(filename: any, text: any): void;
    DownloadVersion(model: any, asXAML: any): Promise<void>;
    CompareThen(model: any): Promise<void>;
    RevertTo(model: any): Promise<void>;
}
export declare class NoderedCtrl {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    static $inject: string[];
    messages: string;
    errormessage: string;
    queuename: string;
    noderedurl: string;
    instance: any;
    instances: any[];
    instancestatus: string;
    instancelog: string;
    name: string;
    instancename: string;
    userid: string;
    user: NoderedUser;
    limitsmemory: string;
    loading: boolean;
    labels: any;
    keys: string[];
    labelkeys: string[];
    label: any;
    newkey: string;
    newvalue: string;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, WebSocketClientService: WebSocketClientService, api: api);
    save(): Promise<void>;
    refreshtimer: NodeJS.Timeout;
    GetNoderedInstance(): Promise<void>;
    GetNoderedInstanceLog(instancename: string): Promise<void>;
    EnsureNoderedInstance(): Promise<void>;
    DeleteNoderedInstance(): Promise<void>;
    DeleteNoderedPod(instancename: string): Promise<void>;
    RestartNoderedInstance(): Promise<void>;
    StartNoderedInstance(): Promise<void>;
    StopNoderedInstance(): Promise<void>;
    addkey(): void;
    removekey(key: any): void;
    newkeyselected(): void;
}
export declare class hdrobotsCtrl extends entitiesCtrl<unattendedclient> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    Enable(model: any): Promise<any>;
    Disable(model: any): Promise<any>;
}
export declare class ClientsCtrl extends entitiesCtrl<unattendedclient> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    showinactive: boolean;
    show: string;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
    ShowWorkflows(model: any): void;
    OpenNodered(model: any): void;
    ManageNodered(model: any): void;
    Impersonate(model: TokenUser): Promise<any>;
}
export declare class AuditlogsCtrl extends entitiesCtrl<Role> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    model: Role;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
    ToggleModal(): void;
    ShowAudit(model: any): Promise<void>;
}
export declare class CredentialsCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processData(): Promise<void>;
    DeleteOneUser(model: TokenUser): Promise<any>;
}
export declare class CredentialCtrl extends entityCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    searchFilteredList: TokenUser[];
    searchSelectedItem: TokenUser;
    searchtext: string;
    e: any;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    submit(): Promise<void>;
    removeuser(_id: any): void;
    adduser(): void;
    isBitSet(base64: string, bit: number): boolean;
    setBit(base64: string, bit: number): string;
    unsetBit(base64: string, bit: number): string;
    toogleBit(a: any, bit: number): void;
    _base64ToArrayBuffer(string_base64: any): ArrayBuffer;
    _arrayBufferToBase64(array_buffer: any): string;
    restrictInput(e: any): boolean;
    setkey(e: any): void;
    handlekeys(): void;
    handlefilter(e: any): Promise<void>;
    fillTextbox(searchtext: any): void;
}
export declare class OAuthClientsCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processData(): Promise<void>;
}
export declare class OAuthClientCtrl extends entityCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    searchFilteredList: TokenUser[];
    searchSelectedItem: TokenUser;
    searchtext: string;
    e: any;
    rolemappings: any;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    submit(): Promise<void>;
    deletefromarray(name: string, id: string): boolean;
    addtoarray(name: string, id: string): boolean;
    addrolemapping(name: string, value: string): boolean;
    deleterolemapping(name: any): boolean;
    CopySecret(field: any): void;
}
export declare class DuplicatesCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    collections: any;
    model: Base;
    uniqeness: string;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    keys: string[];
    processdata(): Promise<void>;
    ToggleUniqeness(model: any): void;
    ShowData(model: any): Promise<void>;
    CloseModal(): Promise<void>;
    ToggleModal(): void;
    OpenEntity(model: any): void;
    MassDeleteOnlyOne(): Promise<void>;
    MassDeleteAllButOne(): Promise<void>;
    MassDeleteAll(): Promise<void>;
    DeleteOnlyOne(model: any): Promise<void>;
    DeleteAllButOne(model: any): Promise<void>;
    DeleteAll(model: any): Promise<void>;
    ModalDeleteOne(model: any): Promise<void>;
}
export declare class DeletedCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    collections: any;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    loadData(): Promise<void>;
    processdata(): void;
    SelectCollection(): void;
}
export declare class CustomersCtrl extends entitiesCtrl<Provider> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: any;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: any, userdata: userdata);
    processData(): Promise<void>;
}
export declare class CustomerCtrl extends entityCtrl<Customer> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    stripe: any;
    nextinvoice: stripe_invoice;
    proration: boolean;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    submit(): Promise<void>;
    Resources: Resource[];
    Assigned: ResourceUsage[];
    UserResources: Resource[];
    UserAssigned: ResourceUsage[];
    support: ResourceUsage[];
    processdata(): Promise<void>;
    ToggleNextInvoiceModal(): void;
    CloseNextInvoiceModal(): void;
    period_start: string;
    period_end: string;
    ShowPlans(): boolean;
    NextInvoice(): Promise<boolean>;
    AssignCount(Product: ResourceVariant): number;
    UserAssignCount(Product: ResourceVariant): number;
    RemovePlan(resource: Resource, product: ResourceVariant): Promise<void>;
    AddPlan2(): Promise<boolean>;
    private resource;
    private product;
    AddPlan(resource: Resource, product: ResourceVariant): Promise<boolean>;
    AddHours(support: ResourceUsage): Promise<void>;
    OpenPortal(): Promise<void>;
    CountryUpdate(): void;
    newdomain: string;
    deletedomain(domain: any): void;
    adddomain(): void;
}
export declare class EntityRestrictionsCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: any;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: any, userdata: userdata);
    processData(): Promise<void>;
    EnsureCommon(): Promise<void>;
    newRestriction(name: string, collection: string, paths: string[], customeradmins: boolean): Promise<void>;
}
export declare class EntityRestrictionCtrl extends entityCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    deleteid(id: any): void;
    newpath: string;
    addid(): void;
    submit(): Promise<void>;
    removeuser(_id: any): void;
    adduser(): void;
    isBitSet(base64: string, bit: number): boolean;
    setBit(base64: string, bit: number): string;
    unsetBit(base64: string, bit: number): string;
    toogleBit(a: any, bit: number): void;
    _base64ToArrayBuffer(string_base64: any): ArrayBuffer;
    _arrayBufferToBase64(array_buffer: any): string;
    searchFilteredList: Role[];
    searchSelectedItem: Role;
    searchtext: string;
    e: any;
    restrictInput(e: any): boolean;
    setkey(e: any): void;
    handlekeys(): void;
    handlefilter(e: any): Promise<void>;
    fillTextbox(searchtext: any): void;
}
export declare class ResourcesCtrl extends entitiesCtrl<Resource> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: any;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: any, userdata: userdata);
    Assigned: ResourceUsage[];
    processData(): Promise<void>;
    AssignCount(resource: Resource): number;
    EnsureCommon(): Promise<void>;
    newProduct(name: string, stripeproduct: string, stripeprice: string, customerassign: "single" | "multiple" | "metered", userassign: "single" | "multiple" | "metered", added_resourceid: string, added_stripeprice: string, added_quantity_multiplier: number, metadata: any, allowdirectassign: boolean, order: number): ResourceVariant;
    newResource(name: string, target: "customer" | "user", customerassign: "singlevariant" | "multiplevariants", userassign: "singlevariant" | "multiplevariants", defaultmetadata: any, products: ResourceVariant[], allowdirectassign: boolean, customeradmins: boolean, order: number): Promise<Resource>;
}
export declare class ResourceCtrl extends entityCtrl<Resource> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    submit(): Promise<void>;
}
export declare class WorkitemsCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    queue: string;
    workitemqueues: Base[];
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    SelectWorkitemqueues(): void;
    SetState(state: any): void;
    DeleteWorkitem(model: any): Promise<void>;
    UpdateWorkitem(model: any, newstate: any): Promise<void>;
    processData(): Promise<void>;
}
export declare class WorkitemCtrl extends entityCtrl<Workitem> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    queue: string;
    workitemqueues: Base[];
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
    fixtextarea(): void;
    submit(): Promise<void>;
}
export declare class WorkitemQueuesCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    queue: string;
    workitemqueues: Base[];
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    DeleteWorkitemQueue(model: any): Promise<void>;
    PurgeWorkitemQueue(model: any): Promise<void>;
    processData(): Promise<void>;
}
export declare class WorkitemQueueCtrl extends entityCtrl<WorkitemQueue> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    projects: Base[];
    workflows: Base[];
    users: Base[];
    amqpqueues: Base[];
    workitemqueues: Base[];
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    loadselects(): Promise<void>;
    processdata(): Promise<void>;
    submit(): Promise<void>;
}
export declare class MailHistsCtrl extends entitiesCtrl<Role> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
}
export declare class MailHistCtrl extends entityCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processData(): Promise<void>;
    submit(): Promise<void>;
}
export declare class WebsocketClientsCtrl extends entitiesCtrl<Base> {
    $rootScope: ng.IRootScopeService;
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: any;
    userdata: userdata;
    constructor($rootScope: ng.IRootScopeService, $scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: any, userdata: userdata);
    processData(): Promise<void>;
    DumpClients(): Promise<void>;
    KillClient(id: any): Promise<void>;
}
